<!-- Template For Tooltip -->
<ng-template #cornerTooltipTmpl>
    <ng-container *ngIf="errorMessage">
        <ng-container *ngIf="errorMessage.length <= 300">{{ errorMessage }}</ng-container>
        <ng-container *ngIf="errorMessage.length > 300">
            {{ errorMessage.substr(0, 300) }}
            <hr> Full Message Available under General Tab.
        </ng-container>
    </ng-container>
    <ng-container *ngIf="warningMessage">
        <ng-container *ngIf="warningMessage.length <= 300">{{ warningMessage }}</ng-container>
        <ng-container *ngIf="warningMessage.length > 300">
            {{ warningMessage.substr(0, 300) }}
            <hr> Full Message Available under General Tab.
        </ng-container>
    </ng-container>
</ng-template>
<div class="card">
    <div class="card-header text-center">
        <!-- Error Tooltip -->
        <span class="widget-corner" [class.d-none]="!errorMessage" [tooltip]="cornerTooltipTmpl" placement="bottom left" containerClass="tooltip-error"
            (click)="onEdit()">
            <i class="fa fa-exclamation"></i>
            <span class="widget-corner-error"></span>
        </span>
        <!-- Warning Tooltip (error message is ALWAYS shown first) -->
        <span class="widget-corner" [class.d-none]="!warningMessage || errorMessage" [tooltip]="cornerTooltipTmpl" placement="bottom left"
            containerClass="tooltip-warning" (click)="onEdit()">
            <i class="fa fa-exclamation"></i>
            <span class="widget-corner-warning"></span>
        </span>
        <!-- Loading indicator -->
        <span class="loading-indicator" [class.d-none]="!isIndicatorVisible" [tooltip]="loadingMessage" placement="bottom left" containerClass="tooltip-loading">
            <i class="fa fa-spinner fa-spin"></i>
        </span>
        <span class="w-100">{{ name }}</span>
        <span class="float-right cursor-pointer">
            <div class="dropdown" dropdown>
                <i class="fa fa-cog" dropdownToggle></i>
                <div *dropdownMenu class="dropdown-menu dropdown-menu-right">
                    <li class="dropdown-item" (click)="onView()">
                        <i class="fa fa-eye"></i>
                        <span>View</span>
                    </li>
                    <li class="dropdown-item" (click)="onEdit()">
                        <i class="fa fa-pencil"></i>
                        <span>Edit</span>
                    </li>
                    <div class="dropdown-divider"></div>
                    <li class="dropdown-item" (click)="onRemove()">
                        <i class="fa fa-trash"></i>
                        <span>Remove</span>
                    </li>
                </div>
            </div>
        </span>
    </div>
    <div class="card-block" [class.widget-mode]="isWidgetViewMode()" [class.view-mode]="isFullViewMode()" [class.edit-mode]="isEditViewMode()">
        <ng-template #viewProviderContainer></ng-template>
        <div class="drag-corner" *ngIf="isWidgetViewMode()" (mousedown)="onResizeStart($event)"></div>
    </div>
</div>

<div class="row mb-5" [class.d-none]="!isEditViewMode()">
    <div class="col-lg-12">
        <hr>
        <tabset justified="true" type="pills">
            <hr>
            <tab heading="General">
                <!-- Title -->
                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text">Title</span>
                    </div>
                    <input type="text" class="form-control" (input)="onNameChange($event)" [value]="name">
                </div>
                <!-- Data Provider Selector -->
                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text">Data Provider</span>
                    </div>
                    <select class="form-control" [ngModel]="this.dataProviderType" (ngModelChange)="onChangeDataProvider($event)">
                        <option [value]="null" disabled>—</option>
                        <option *ngFor="let config of availableDataProviders" [ngValue]="config.provider">{{ config.name }}</option>
                    </select>
                </div>

                <!-- Mapping Provider Selector -->
                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text">Mapping Provider</span>
                    </div>
                    <select class="form-control" [ngModel]="this.mappingProviderType" (ngModelChange)="onChangeMappingProvider($event)">
                        <option [value]="null" disabled>—</option>
                        <option *ngFor="let config of availableMappingProviders" [ngValue]="config.provider">{{ config.name }}</option>
                    </select>
                </div>

                <!-- Error Message Panel (if any) -->
                <div class="response-error-panel" *ngIf="errorMessage">
                    {{ errorMessage }}
                </div>

                <!-- Warning Message Panel (if any) -->
                <div class="response-error-panel" *ngIf="warningMessage">
                    {{ warningMessage }}
                </div>
            </tab>
            <tab heading="View Provider" [disabled]="!canConfigureViewProvider()">
                <ng-template #viewProviderEditorContainer></ng-template>
            </tab>
            <tab heading="Data Provider" [disabled]="!canConfigureDataProvider()">
                <ng-template #dataProviderEditorContainer></ng-template>
            </tab>
        </tabset>
    </div>
</div>